
import zmq
#defaults
pub_address = "tcp://127.0.0.1:5050"
server_address = "tcp://127.0.0.1:5052"

class Error():
    def __init__(self,id,msg):
        self.id = id
        self.message = msg
        
def is_error(self):
    return isinstance(self,Error)

class Metatrader():
    is_init = False
    def __init__(self,id,address):
        self.id = id
        self.address = address
    def request(self,msg,retry=3,timeout=1000):
        info = request(self,msg,self.address,retry,timeout)
        if not info:
            return Error(-2,"Connection timed out");
        if info!=None and info[0]=="Error":
            return Error(info[1],info[2])
        return info[1:]
    def get(self):
        info = self.request("Account")
        if info==None or is_error(info):
            return False
        name,number,server,leverage,currency,company,is_trade_allowed,is_connected,is_demo,profit,margin,balance,credit,equity,free_margin,orders_history_total,timestamp = info
        self.name = name
        self.number = int(number)
        self.server = server
        self.leverage=int(leverage)
        self.currency = currency
        self.company = company
        self.is_trade_allowed = bool(int(is_trade_allowed))
        self.is_connected = bool(int(is_connected))
        self.is_demo = bool(int(is_demo))
        self.profit = float(profit)
        self.margin = float(margin)
        self.balance = float(balance)
        self.credit = float(credit)
        self.equity = float(equity)
        self.free_margin = float(free_margin)
        self.orders_history_total = int(orders_history_total)
        self.timestamp = int(timestamp)
        self.is_init=True
        return True

 
def request(self,msg,address=server_address,retry=3,timeout=1000):
    #setup socket!
    context = zmq.Context()
    poll = zmq.Poller()
    tries = -1
    try:
        while (tries<retry):
            try:
                s = context.socket(zmq.REQ)
                s.connect(address)
                poll.register(s)       
                s.send_multipart([self.id,msg],zmq.NOBLOCK) 
                if (poll.poll(timeout)!=[]):
                    message = s.recv_multipart()
                    #This is a hack - server must always return a value (its REQ/REP), so... if it wrong thing, we return
                    #This should only happen if we accidently place wrong accounts on same server and zeromq load balances to different accounts!
                    if (message[0]==""):
                        return None
                    return message
                tries+=1
            finally:
                s.setsockopt(zmq.LINGER, 0)
                s.close()
                poll.unregister(s)
    finally:
        context.term()
    return None

def connect(id,server=None,timeout=3000,address = pub_address):
    id = str(id)
    
    import time
    context = zmq.Context()
    s = context.socket(zmq.SUB)
    s.connect(address)
    s.setsockopt(zmq.SUBSCRIBE,'')
    poll = zmq.core.poll.Poller()
    poll.register(s)
    
    date = time.time()
    try:
        while True:
            if (poll.poll(timeout)!=[]):
                identity = s.recv_multipart()
                ss = identity[0].split()
                if len(ss)==2 and len(identity)==2:
                    r_server,r_id = ss
                    if (id==r_id and server==r_server or id==r_id and server==None):
                        return Metatrader(identity[0],identity[1])
            if (time.time()-date >=timeout/1000.0):
                return None
    finally:
        s.setsockopt(zmq.LINGER, 0)
        s.close()
        context.term()
